Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 3270)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 3271)
@@ -66,7 +66,7 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt             ! ocean time-step
-      !
-      INTEGER             ::  ierr,  kindic   ! local integer
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step
+      !
+      INTEGER             ::  ierr   ! local integer
       !!---------------------------------------------------------------------
       !
@@ -79,7 +79,7 @@
       !
       IF( .NOT.lk_iomput ) THEN
-                          CALL trcdit_wr( kt, kindic )      ! outputs for tracer concentration
-         IF( ln_diatrc )  CALL trcdii_wr( kt, kindic )      ! outputs for additional arrays
-         IF( ln_diabio )  CALL trcdib_wr( kt, kindic )      ! outputs for biological trends
+                          CALL trcdit_wr( kt )      ! outputs for tracer concentration
+         IF( ln_diatrc )  CALL trcdii_wr( kt )      ! outputs for additional arrays
+         IF( ln_diabio )  CALL trcdib_wr( kt )      ! outputs for biological trends
       ENDIF
       !
@@ -87,5 +87,5 @@
 
 
-   SUBROUTINE trcdit_wr( kt, kindic )
+   SUBROUTINE trcdit_wr( kt )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE trcdit_wr  ***
@@ -99,10 +99,6 @@
       !!        Each nwritetrc time step, output the instantaneous or mean fields
       !!
-      !!        IF kindic <0, output of fields before the model interruption.
-      !!        IF kindic =0, time step loop
-      !!        IF kindic >0, output of fields before the time step loop
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt       ! ocean time-step
-      INTEGER, INTENT(in) ::   kindic   ! indicator of abnormal termination
       !
       INTEGER ::   jn
@@ -150,5 +146,5 @@
       ! --------------------------------------------------------------
 
-      IF(ll_print)WRITE(numout,*)'trcdit_wr kt=',kt,' kindic ',kindic
+      IF(ll_print)WRITE(numout,*)'trcdit_wr kt=',kt
       
       IF( kt == nittrc000 ) THEN
@@ -231,9 +227,9 @@
       ! close the file 
       ! --------------
-      IF( kt == nitend .OR. kindic < 0 )   CALL histclo( nit5 )
+      IF( kt == nitend )   CALL histclo( nit5 )
       !
    END SUBROUTINE trcdit_wr
 
-   SUBROUTINE trcdii_wr( kt, kindic )
+   SUBROUTINE trcdii_wr( kt )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE trcdii_wr  ***
@@ -247,10 +243,6 @@
       !!        Each nn_writedia time step, output the instantaneous or mean fields
       !!
-      !!        IF kindic <0, output of fields before the model interruption.
-      !!        IF kindic =0, time step loop
-      !!        IF kindic >0, output of fields before the time step loop
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt       ! ocean time-step
-      INTEGER, INTENT(in) ::   kindic   ! indicator of abnormal termination
       !!
       LOGICAL ::   ll_print = .FALSE.
@@ -297,5 +289,5 @@
       ! -----------------------------------------------------------------
 
-      IF( ll_print ) WRITE(numout,*) 'trcdii_wr kt=', kt, ' kindic ', kindic
+      IF( ll_print ) WRITE(numout,*) 'trcdii_wr kt=', kt
 
       IF( kt == nittrc000 ) THEN
@@ -371,10 +363,10 @@
       ! Closing all files
       ! -----------------
-      IF( kt == nitend .OR. kindic < 0 )   CALL histclo(nitd)
+      IF( kt == nitend )   CALL histclo(nitd)
       !
 
    END SUBROUTINE trcdii_wr
 
-   SUBROUTINE trcdib_wr( kt, kindic )
+   SUBROUTINE trcdib_wr( kt )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE trcdib_wr  ***
@@ -388,10 +380,6 @@
       !!        Each nn_writebio time step, output the instantaneous or mean fields
       !!
-      !!        IF kindic <0, output of fields before the model interruption.
-      !!        IF kindic =0, time step loop
-      !!        IF kindic >0, output of fields before the time step loop
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt          ! ocean time-step
-      INTEGER, INTENT( in ) ::   kindic      ! indicator of abnormal termination
       !!
       LOGICAL ::   ll_print = .FALSE.
@@ -438,5 +426,5 @@
       ! --------------------------------------------------------------
 
-      IF(ll_print) WRITE(numout,*)'trcdib_wr kt=',kt,' kindic ',kindic
+      IF(ll_print) WRITE(numout,*)'trcdib_wr kt=',kt
 
       IF( kt == nittrc000 ) THEN
@@ -488,5 +476,5 @@
       ! Closing all files
       ! -----------------
-      IF( kt == nitend .OR. kindic < 0 )   CALL histclo( nitb )
+      IF( kt == nitend )   CALL histclo( nitb )
       !
    END SUBROUTINE trcdib_wr