Index: /trunk/DOC/TexFiles/Namelist/namrun
===================================================================
--- /trunk/DOC/TexFiles/Namelist/namrun	(revision 3305)
+++ /trunk/DOC/TexFiles/Namelist/namrun	(revision 3306)
@@ -2,14 +2,16 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      =  "ORCA2"  !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =    5475   !  last  time step (std 5475)
-   nn_date0    =  010101   !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  010101   !  date at nit_0000 (format yyyymmdd)
+                           !  used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =       0   !  Leap year calendar (1) or not (0)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+       !  = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+       !  = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+       !  = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
Index: /trunk/NEMOGCM/CONFIG/AMM12/EXP00/namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3305)
+++ /trunk/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3306)
@@ -24,14 +24,15 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      =  "AMM12"  !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =     576   !  last  time step (std 1 day = 576)
-   nn_date0    =  20070101 !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  20070101 !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =       1   !  Leap year calendar (1) or not (0)
    ln_rstart   =  .false.  !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+                           !    = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+                           !    = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+                           !    = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
Index: /trunk/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist	(revision 3305)
+++ /trunk/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist	(revision 3306)
@@ -24,14 +24,15 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      =  "AMM12"  !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =     576   !  last  time step (std 1 day = 576)
-   nn_date0    =  20070101 !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  20070101 !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =       1   !  Leap year calendar (1) or not (0)
    ln_rstart   =  .false.  !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+                           !    = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+                           !    = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+                           !    = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
Index: /trunk/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3305)
+++ /trunk/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3306)
@@ -24,14 +24,15 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      =  "GYRE"   !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =    4320   !  last  time step
-   nn_date0    =  010101   !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  010101   !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =      30   !  Leap year calendar (1) or not (0)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+                           !    = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+                           !    = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+                           !    = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 3305)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 3306)
@@ -24,14 +24,15 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      = "Agulhas" !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =   10950   !  last  time step
-   nn_date0    =  010101   !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  010101   !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =       0   !  Leap year calendar (1) or not (0)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+                           !    = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+                           !    = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+                           !    = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3305)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3306)
@@ -24,14 +24,15 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      =  "ORCA2"  !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =    5475   !  last  time step (std 5475)
-   nn_date0    =  010101   !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  010101   !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =       0   !  Leap year calendar (1) or not (0)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+                           !    = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+                           !    = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+                           !    = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
Index: /trunk/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3305)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3306)
@@ -24,14 +24,15 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_no       =       0   !  job number
+   nn_no       =       0   !  job number (no more used...)
    cn_exp      =  "PISCES"  !  experience name 
    nn_it000    =       1   !  first time step
    nn_itend    =    1460   !  last  time step (std 5475)
-   nn_date0    =  010101   !  initial calendar date yymmdd (used if nn_rstctl=1)
+   nn_date0    =  010101   !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
    nn_leapy    =       0   !  Leap year calendar (1) or not (0)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
-   nn_rstctl   =       0       !  restart control = 0 nn_it000 is not compared to the restart file value
-                               !                  = 1 use nn_date0 in namelist (not the value in the restart file)
-                               !                  = 2 calendar parameters read in the restart file
+   nn_rstctl   =       0   !  restart control => activated only if ln_rstart = T
+                           !    = 0 nn_date0 read in namelist ; nn_it000 : read in namelist
+                           !    = 1 nn_date0 read in namelist ; nn_it000 : check consistancy between namelist and restart
+                           !    = 2 nn_date0 read in restart  ; nn_it000 : check consistancy between namelist and restart
    cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
    cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)