Index: branches/CMIP5_IPSL/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml
===================================================================
--- branches/CMIP5_IPSL/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 1803)
+++ branches/CMIP5_IPSL/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 3307)
@@ -44,40 +44,64 @@
      </group>
 
-      <!-- diad on T grid -->
+      <!-- diad on T grid : : variables available with key_trc_diaadd && key_trc_dia3d -->
 
      <group id="diad_T" axis_ref="none" grid_ref="grid_T">
-       <field id="PH"          description="PH"                                       unit="-"            axis_ref="deptht" />
-       <field id="CO3"         description="Bicarbonates"                             unit="mol/L"        axis_ref="deptht" />
-       <field id="CO3sat"      description="CO3 saturation"                           unit="mol/L"        axis_ref="deptht" />
-       <field id="PAR"         description="Photosynthetically Available Radiation"   unit="W/m2"         axis_ref="deptht" />
-       <field id="PPPHY"       description="Primary production of nanophyto"          unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="PPPHY2"      description="Primary production of diatoms"            unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="PPNEWN"      description="New Primary production of nanophyto"      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="PPNEWD"      description="New Primary production of diatoms"        unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="PBSi"        description="Primary production of Si diatoms"         unit="mol-Si/m3/s"  axis_ref="deptht" />
-       <field id="PFeN"        description="Primary production of nano iron"          unit="mol-Fe/m3/s"  axis_ref="deptht" />
-       <field id="PFeD"        description="Primary production of diatoms iron"       unit="mol-Fe/m3/s"  axis_ref="deptht" />
-       <field id="Pcal"        description="Calcite production"                       unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Dcal"        description="Calcite dissolution"                      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Graz"        description="Grazing by microzoo"                      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Graz2"       description="Grazing by mesozoo"                       unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Nfix"        description="Nitrogen fixation"                        unit="mol-N/m2/s"   axis_ref="deptht" />
-       <field id="ExpPOC"      description="POC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="ExpGOC"      description="GOC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="ExpFe1"      description="Nano iron export"                         unit="mol-Fe/m2/s"  axis_ref="deptht" />
-       <field id="ExpFe2"      description="Diatoms iron export"                      unit="mol-Fe/m2/s"  axis_ref="deptht" />
-       <field id="ExpSi"       description="Silicate export"                          unit="mol-Si/m2/s"  axis_ref="deptht" />
-       <field id="Expcal"      description="Calcite export"                           unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="Cflx"        description="DIC flux"                                 unit="mol-C/m2/s" />
-       <field id="Oflx"        description="Oxygen flux"                              unit="mol-C/m2/s" />
-       <field id="Kg"          description="Gas transfer"                             unit="mol-C/m2/s/uatm" />
-       <field id="Dpco2"       description="Delta CO2"                                unit="uatm" />
-       <field id="Dpo2"        description="Delta O2"                                 unit="uatm" />
-       <field id="Heup"        description="Euphotic layer depth"                     unit="m" />
-       <field id="Irondep"     description="Iron deposition"                          unit="mol-Fe/m2/s" />
+       <field id="PH"          description="PH"                                       unit="-"           axis_ref="deptht" />
+       <field id="CO3"         description="Bicarbonates"                             unit="mol/L"       axis_ref="deptht" />
+       <field id="CO3sat"      description="CO3 saturation"                           unit="mol/L"       axis_ref="deptht" />
+       <field id="PAR"         description="Photosynthetically Available Radiation"   unit="W/m2"        axis_ref="deptht" />
+       <field id="PPPHY"       description="Primary production of nanophyto"          unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="PPPHY2"      description="Primary production of diatoms"            unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="PPNEWN"      description="New Primary production of nanophyto"      unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="PPNEWD"      description="New Primary production of diatoms"        unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="PBSi"        description="Primary production of Si diatoms"         unit="molSi/m3/s"  axis_ref="deptht" />
+       <field id="PFeN"        description="Primary production of nano iron"          unit="molFe/m3/s"  axis_ref="deptht" />
+       <field id="PFeD"        description="Primary production of diatoms iron"       unit="molFe/m3/s"  axis_ref="deptht" />
+       <field id="PCAL"        description="Calcite production"                       unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="DCAL"        description="Calcite dissolution"                      unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="GRAZ"        description="Grazing by zooplankton"                   unit="molC/m3/s"   axis_ref="deptht" />
+       <field id="Nfix"        description="Nitrogen fixation at surface"             unit="molN/m2/s"      />
+       <field id="EPC100"      description="Export of carbon particles at 100 m"      unit="molC/m2/s"      />
+       <field id="EPFE100"     description="Export of biogenic iron at 100 m"         unit="molFe/m2/s"     />
+       <field id="EPSI100"     description="Export of Silicate at 100 m"              unit="molSi/m2/s"     />
+       <field id="EPCAL100"    description="Export of Calcite at 100 m"               unit="molC/m2/s"      />
+       <field id="Cflx"        description="DIC flux"                                 unit="molC/m2/s"      />
+       <field id="Oflx"        description="Oxygen flux"                              unit="molC/m2/s"      />
+       <field id="Kg"          description="Gas transfer"                             unit="molC/m2/s/uatm" />
+       <field id="Dpco2"       description="Delta CO2"                                unit="uatm"            />
+       <field id="Dpo2"        description="Delta O2"                                 unit="uatm"            />
+       <field id="Heup"        description="Euphotic layer depth"                     unit="m"               />
+       <field id="Irondep"     description="Iron deposition"                          unit="molFe/m2/s"     />
      </group>
 
+      <!-- dbio_T on T grid : variables available with key_diaar5 -->
+     <group id="dbio_T" axis_ref="none" grid_ref="grid_T">
+       <field id="PHYT"        description="Total phytoplankton Concentration"                   unit="molC/L"     axis_ref="deptht" />
+       <field id="ZOOT"        description="Total zooplankton Concentration"                     unit="molC/L"     axis_ref="deptht" />
+       <field id="CHLT"        description="Total chlorophyll Concentration"                     unit="gChl/L"     axis_ref="deptht" />
+       <field id="POCT"        description="Total carbon particles Concentration"                unit="molC/L"     axis_ref="deptht" />
+       <field id="PFET"        description="Total biogenic Iron Concentration"                   unit="molFe/L"     axis_ref="deptht" />
+       <field id="TPP"         description="Total Primary production of phyto"                   unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="TPNEW"       description="New Primary production of phyto"                     unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="TPBFE"       description="Total biogenic iron production"                      unit="molFe/m3/s" axis_ref="deptht" />
+       <field id="EXPC"        description="Export of carbon"                                    unit="molC/m2/s"  axis_ref="deptht" />
+       <field id="EXPFE"       description="Export of biogenic iron"                             unit="molFe/m2/s" axis_ref="deptht" />
+       <field id="EXPSI"       description="Export of Silicate"                                  unit="molSi/m2/s" axis_ref="deptht" />
+       <field id="EXPCAL"      description="Export of Calcite"                                   unit="molC/m2/s"  axis_ref="deptht" />
+       <field id="PHSFC"       description="PH at surface"                                       unit="-"       />
+       <field id="INTDIC"      description="DIC content"                                         unit="kg/m2"   />
+       <field id="O2MIN"       description="Oxygen minimum concentration"                        unit="molC/L" />
+       <field id="ZO2MIN"      description="Depth of oxygen minimum concentration"               unit="m"       />
+       <field id="INTNFIX"     description="Nitrogen fixation rate : vert. integrated"           unit="molN/m2/s"  />
+       <field id="INTPPPHY"    description="Vertically integrated primary production by nanophy" unit="molC/m2/s"  />
+       <field id="INTPPPHY2"   description="Vertically integrated primary production by diatom"  unit="molC/m2/s"  />
+       <field id="INTPP"       description="Vertically integrated primary production by phyto"   unit="molC/m2/s"  />
+       <field id="INTPNEW"     description="Vertically integrated new primary production"        unit="molC/m2/s"  />
+       <field id="INTPBFE"     description="Vertically integrated of biogenic iron production"   unit="molFe/m2/s" />
+       <field id="INTPBSI"     description="Vertically integrated of biogenic Si production"     unit="molSi/m2/s" />
+       <field id="INTPCAL"     description="Vertically integrated of calcite production"         unit="molSi/m2/s" />
+     </group>
+
       <!-- scalar -->
-      
       <group id="scalar" axis_ref="none" grid_ref="scalarpoint" zoom_ref="1point" >
       </group>
@@ -166,33 +190,30 @@
 
        <file id="1y_diad_T" name="auto" description="additional pisces diagnostics" >
-          <field ref="PH"       />
-          <field ref="CO3"      />
-          <field ref="CO3sat"   />
-          <field ref="PAR"      />
-          <field ref="PPPHY"    />
-          <field ref="PPPHY2"   />
-          <field ref="PPNEWN"   />
-          <field ref="PPNEWD"   />
-          <field ref="PBSi"     />
-          <field ref="PFeN"     />
-          <field ref="PFeD"     />
-          <field ref="Pcal"     />
-          <field ref="Dcal"     />
-          <field ref="Graz"     />
-          <field ref="Graz2"    />
-          <field ref="Cflx"     />
-          <field ref="ExpPOC"   />
-          <field ref="ExpGOC"   />
-          <field ref="ExpFe1"   />
-          <field ref="ExpFe2"   />
-          <field ref="ExpSi"    />
-          <field ref="Expcal"   />
-          <field ref="Oflx"     />
-          <field ref="Kg"       />
-          <field ref="Dpco2"    />
-          <field ref="Dpo2"     />
-          <field ref="Heup"     />
-          <field ref="Irondep"  />
-          <field ref="Nfix"     />
+          <field id="PH"          description="PH"                                       unit="-"           axis_ref="deptht" />
+          <field id="CO3"         description="Bicarbonates"                             unit="mol/L"       axis_ref="deptht" />
+          <field id="CO3sat"      description="CO3 saturation"                           unit="mol/L"       axis_ref="deptht" />
+          <field id="PAR"         description="Photosynthetically Available Radiation"   unit="W/m2"        axis_ref="deptht" />
+          <field id="PPPHY"       description="Primary production of nanophyto"          unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="PPPHY2"      description="Primary production of diatoms"            unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="PPNEWN"      description="New Primary production of nanophyto"      unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="PPNEWD"      description="New Primary production of diatoms"        unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="PBSi"        description="Primary production of Si diatoms"         unit="molSi/m3/s"  axis_ref="deptht" />
+          <field id="PFeN"        description="Primary production of nano iron"          unit="molFe/m3/s"  axis_ref="deptht" />
+          <field id="PFeD"        description="Primary production of diatoms iron"       unit="molFe/m3/s"  axis_ref="deptht" />
+          <field id="PCAL"        description="Calcite production"                       unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="DCAL"        description="Calcite dissolution"                      unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="GRAZ"        description="Grazing by zooplankton"                   unit="molC/m3/s"   axis_ref="deptht" />
+          <field id="Nfix"        description="Nitrogen fixation at surface"             unit="molN/m2/s"      />
+          <field id="EPC100"      description="Export of carbon particles at 100 m"      unit="molC/m2/s"      />
+          <field id="EPFE100"     description="Export of biogenic iron at 100 m"         unit="molFe/m2/s"     />
+          <field id="EPSI100"     description="Export of Silicate at 100 m"              unit="molSi/m2/s"     />
+          <field id="EPCAL100"    description="Export of Calcite at 100 m"               unit="molC/m2/s"      />
+          <field id="Cflx"        description="DIC flux"                                 unit="molC/m2/s"      />
+          <field id="Oflx"        description="Oxygen flux"                              unit="molC/m2/s"      />
+          <field id="Kg"          description="Gas transfer"                             unit="molC/m2/s/uatm" />
+          <field id="Dpco2"       description="Delta CO2"                                unit="uatm"            />
+          <field id="Dpo2"        description="Delta O2"                                 unit="uatm"            />
+          <field id="Heup"        description="Euphotic layer depth"                     unit="m"               />
+          <field id="Irondep"     description="Iron deposition"                          unit="molFe/m2/s"     />
        </file>
 