Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdglo.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdglo.F90	(revision 3318)
@@ -1,6 +1,6 @@
-MODULE trdicp
+MODULE trdglo
    !!======================================================================
-   !!                       ***  MODULE  trdicp  ***
-   !! Ocean diagnostics:  ocean tracers and dynamic trends
+   !!                       ***  MODULE  trdglo  ***
+   !! Ocean diagnostics:  global domain averaged tracer and momentum trends
    !!=====================================================================
    !! History :  1.0  !  2004-08 (C. Talandier) New trends organization
@@ -9,15 +9,14 @@
 
    !!----------------------------------------------------------------------
-   !!   trd_budget     : domain averaged budget of trends (including kinetic energy and T^2 trends)
-   !!   trd_icp        : compute the basin averaged properties for tra/dyn 
-   !!   trd_dwr        : print dynmaic trends in ocean.output file
-   !!   trd_twr        : print tracers trends in ocean.output file
-   !!   trd_icp_init   : initialization step
+   !!   trd_glo      : domain averaged budget of trends (including kinetic energy and T^2 trends)
+   !!   glo_dyn_wri  : print dynamic trends in ocean.output file
+   !!   glo_tra_wri  : print global T & T^2 trends in ocean.output file
+   !!   trd_glo_init : initialization step
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
    USE sbc_oce         ! surface boundary condition: ocean
+   USE trd_oce         ! trends: ocean variables
    USE phycst          ! physical constants
-   USE trdmod_oce      ! ocean variables trends
    USE ldftra_oce      ! ocean active tracers: lateral physics
    USE ldfdyn_oce      ! ocean dynamics: lateral physics
@@ -35,8 +34,6 @@
    PRIVATE
 
-   PUBLIC   trd_budget    ! called by trdmod.F90
-   PUBLIC   trd_dwr       ! called by step.F90
-   PUBLIC   trd_twr       ! called by step.F90
-   PUBLIC   trd_icp_init  ! called by opa.F90
+   PUBLIC   trd_glo       ! called by trdtra and trddyn modules
+   PUBLIC   trd_glo_init  ! called by trdini module
 
    !                     !!! Variables used for diagnostics
@@ -64,15 +61,16 @@
 CONTAINS
 
-   SUBROUTINE trd_budget( ptrdx, ptrdy, ktrd, ctype, kt )
+   SUBROUTINE trd_glo( ptrdx, ptrdy, ktrd, ctype, kt )
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_budget  ***
+      !!                  ***  ROUTINE trd_glo  ***
       !! 
-      !! ** Purpose : integral constraint diagnostics for momentum and/or tracer trends
-      !!              
+      !! ** Purpose :   compute and print global domain averaged trends for 
+      !!              T, T^2, momentum, KE, and KE<->PE
+      !!
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   ptrdx   ! Temperature or U trend 
       REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   ptrdy   ! Salinity    or V trend
       INTEGER                   , INTENT(in   ) ::   ktrd    ! tracer trend index
-      CHARACTER(len=3)          , INTENT(in   ) ::   ctype   ! momentum or tracers trends type 'DYN'/'TRA'
+      CHARACTER(len=3)          , INTENT(in   ) ::   ctype   ! momentum or tracers trends type (='DYN'/'TRA')
       INTEGER                   , INTENT(in   ) ::   kt      ! time step
       !!
@@ -104,16 +102,16 @@
             END DO
             !                       ! linear free surface: diagnose advective flux trough the fixed k=1 w-surface
-            IF( .NOT.lk_vvl .AND. ktrd == jptra_trd_zad ) THEN  
-               tmo(jptra_trd_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_tem) * e1e2t(:,:) )
-               smo(jptra_trd_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_sal) * e1e2t(:,:)  )
-               t2 (jptra_trd_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_tem) * tsn(:,:,1,jp_tem) * e1e2t(:,:)  )
-               s2 (jptra_trd_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_sal) * tsn(:,:,1,jp_sal) * e1e2t(:,:)  )
+            IF( .NOT.lk_vvl .AND. ktrd == jptra_zad ) THEN  
+               tmo(jptra_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_tem) * e1e2t(:,:) )
+               smo(jptra_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_sal) * e1e2t(:,:)  )
+               t2 (jptra_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_tem) * tsn(:,:,1,jp_tem) * e1e2t(:,:)  )
+               s2 (jptra_sad) = SUM( wn(:,:,1) * tsn(:,:,1,jp_sal) * tsn(:,:,1,jp_sal) * e1e2t(:,:)  )
             ENDIF
             !
-            IF( ktrd == jptra_trd_atf ) THEN     ! last trend (asselin time filter)
+            IF( ktrd == jptra_atf ) THEN     ! last trend (asselin time filter)
                ! 
-               CALL trd_twr( kt )   ! print the results in ocean.output
+               CALL glo_tra_wri( kt )             ! print the results in ocean.output
                !                
-	            tmo(:) = 0._wp       ! prepare the next time step (domain averaged array reset to zero)
+	            tmo(:) = 0._wp                     ! prepare the next time step (domain averaged array reset to zero)
    	         smo(:) = 0._wp
                t2 (:) = 0._wp
@@ -137,5 +135,5 @@
             END DO
             !                 
-            IF( ktrd == jpdyn_trd_zdf ) THEN      ! zdf trend: compute separately the surface forcing trend
+            IF( ktrd == jpdyn_zdf ) THEN      ! zdf trend: compute separately the surface forcing trend
                z1_2rau0 = 0.5_wp / rau0
                DO jj = 1, jpjm1
@@ -145,12 +143,12 @@
                      zvs = ( vtau_b(ji,jj) + vtau(ji,jj) ) * tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)   &
                         &                       * z1_2rau0 * e1v    (ji  ,jj  ) * e2v    (ji,jj) * fse3u(ji,jj,jk)
-                     umo(jpdyn_trd_tau) = umo(jpdyn_trd_tau) + zvt
-                     vmo(jpdyn_trd_tau) = vmo(jpdyn_trd_tau) + zvs
-                     hke(jpdyn_trd_tau) = hke(jpdyn_trd_tau) + un(ji,jj,1) * zvt + vn(ji,jj,1) * zvs
+                     umo(jpdyn_tau) = umo(jpdyn_tau) + zvt
+                     vmo(jpdyn_tau) = vmo(jpdyn_tau) + zvs
+                     hke(jpdyn_tau) = hke(jpdyn_tau) + un(ji,jj,1) * zvt + vn(ji,jj,1) * zvs
                   END DO
                END DO
             ENDIF
             !                       
-            IF( ktrd == jpdyn_trd_atf ) THEN     ! last trend (asselin time filter)
+            IF( ktrd == jpdyn_atf ) THEN     ! last trend (asselin time filter)
                !
                IF( ln_bfrimp ) THEN                   ! implicit bfr case: compute separately the bottom friction 
@@ -162,12 +160,12 @@
                         zvt = bfrua(ji,jj) * un(ji,jj,ikbu) * e1u(ji,jj) * e2v(ji,jj)
                         zvs = bfrva(ji,jj) * vn(ji,jj,ikbv) * e1v(ji,jj) * e2v(ji,jj)
-                        umo(jpdyn_trd_bfr) = umo(jpdyn_trd_bfr) + zvt
-                        vmo(jpdyn_trd_bfr) = vmo(jpdyn_trd_bfr) + zvs
-                        hke(jpdyn_trd_bfr) = hke(jpdyn_trd_bfr) + un(ji,jj,ikbu) * zvt + vn(ji,jj,ikbv) * zvs
+                        umo(jpdyn_bfr) = umo(jpdyn_bfr) + zvt
+                        vmo(jpdyn_bfr) = vmo(jpdyn_bfr) + zvs
+                        hke(jpdyn_bfr) = hke(jpdyn_bfr) + un(ji,jj,ikbu) * zvt + vn(ji,jj,ikbv) * zvs
                      END DO
                   END DO
                ENDIF
                ! 
-               CALL trd_dwr( kt )                     ! print the results in ocean.output
+               CALL glo_dyn_wri( kt )                 ! print the results in ocean.output
                !                
                umo(:) = 0._wp                         ! reset for the next time step
@@ -183,10 +181,10 @@
       CALL wrk_dealloc( jpi, jpj, ztswu, ztswv, z2dx, z2dy )
       !
-   END SUBROUTINE trd_budget
-
-
-   SUBROUTINE trd_icp_init
+   END SUBROUTINE trd_glo
+
+
+   SUBROUTINE trd_glo_init
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_icp_init  ***
+      !!                  ***  ROUTINE trd_glo_init  ***
       !! 
       !! ** Purpose :   Read the namtrd namelist
@@ -197,5 +195,5 @@
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'trd_icp_init : integral constraints properties trends'
+         WRITE(numout,*) 'trd_glo_init : integral constraints properties trends'
          WRITE(numout,*) '~~~~~~~~~~~~~'
       ENDIF
@@ -210,5 +208,4 @@
       IF(lwp) WRITE(numout,*) '                total ocean volume at T-point   tvolt = ',tvolt
 
-#if  defined key_trddyn
       ! Initialization of potential to kinetic energy conversion
       rpktrd = 0._wp
@@ -233,14 +230,13 @@
          WRITE(numout,*) '                total ocean volume at V-point   tvolv = ',tvolv
       ENDIF
-#endif
-      !
-   END SUBROUTINE trd_icp_init
-
-
-   SUBROUTINE trd_dwr( kt )
+      !
+   END SUBROUTINE trd_glo_init
+
+
+   SUBROUTINE glo_dyn_wri( kt )
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_dwr  ***
+      !!                  ***  ROUTINE glo_dyn_wri  ***
       !! 
-      !! ** Purpose :  write dynamic trends in ocean.output 
+      !! ** Purpose :  write global averaged U, KE, PE<->KE trends in ocean.output 
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -319,23 +315,23 @@
             WRITE (numout,*)
             WRITE (numout,9500) kt
-            WRITE (numout,9501) umo(jpdyn_trd_hpg) / tvolu, vmo(jpdyn_trd_hpg) / tvolv
-            WRITE (numout,9509) umo(jpdyn_trd_spg) / tvolu, vmo(jpdyn_trd_spg) / tvolv
-            WRITE (numout,9502) umo(jpdyn_trd_keg) / tvolu, vmo(jpdyn_trd_keg) / tvolv
-            WRITE (numout,9503) umo(jpdyn_trd_rvo) / tvolu, vmo(jpdyn_trd_rvo) / tvolv
-            WRITE (numout,9504) umo(jpdyn_trd_pvo) / tvolu, vmo(jpdyn_trd_pvo) / tvolv
-            WRITE (numout,9507) umo(jpdyn_trd_zad) / tvolu, vmo(jpdyn_trd_zad) / tvolv
-            WRITE (numout,9505) umo(jpdyn_trd_ldf) / tvolu, vmo(jpdyn_trd_ldf) / tvolv
-            WRITE (numout,9508) umo(jpdyn_trd_zdf) / tvolu, vmo(jpdyn_trd_zdf) / tvolv
-            WRITE (numout,9510) umo(jpdyn_trd_tau) / tvolu, vmo(jpdyn_trd_tau) / tvolv
-            WRITE (numout,9511) umo(jpdyn_trd_bfr) / tvolu, vmo(jpdyn_trd_bfr) / tvolv
-            WRITE (numout,9512) umo(jpdyn_trd_atf) / tvolu, vmo(jpdyn_trd_atf) / tvolv
+            WRITE (numout,9501) umo(jpdyn_hpg) / tvolu, vmo(jpdyn_hpg) / tvolv
+            WRITE (numout,9509) umo(jpdyn_spg) / tvolu, vmo(jpdyn_spg) / tvolv
+            WRITE (numout,9502) umo(jpdyn_keg) / tvolu, vmo(jpdyn_keg) / tvolv
+            WRITE (numout,9503) umo(jpdyn_rvo) / tvolu, vmo(jpdyn_rvo) / tvolv
+            WRITE (numout,9504) umo(jpdyn_pvo) / tvolu, vmo(jpdyn_pvo) / tvolv
+            WRITE (numout,9507) umo(jpdyn_zad) / tvolu, vmo(jpdyn_zad) / tvolv
+            WRITE (numout,9505) umo(jpdyn_ldf) / tvolu, vmo(jpdyn_ldf) / tvolv
+            WRITE (numout,9508) umo(jpdyn_zdf) / tvolu, vmo(jpdyn_zdf) / tvolv
+            WRITE (numout,9510) umo(jpdyn_tau) / tvolu, vmo(jpdyn_tau) / tvolv
+            WRITE (numout,9511) umo(jpdyn_bfr) / tvolu, vmo(jpdyn_bfr) / tvolv
+            WRITE (numout,9512) umo(jpdyn_atf) / tvolu, vmo(jpdyn_atf) / tvolv
             WRITE (numout,9513)
             WRITE (numout,9514)                                                 &
-            &     (  umo(jpdyn_trd_hpg) + umo(jpdyn_trd_spg) + umo(jpdyn_trd_keg) + umo(jpdyn_trd_rvo)   &
-            &      + umo(jpdyn_trd_pvo) + umo(jpdyn_trd_zad) + umo(jpdyn_trd_ldf) + umo(jpdyn_trd_zdf)   &
-            &      + umo(jpdyn_trd_tau) + umo(jpdyn_trd_bfr) + umo(jpdyn_trd_atf) ) / tvolu,   &
-            &     (  vmo(jpdyn_trd_hpg) + vmo(jpdyn_trd_spg) + vmo(jpdyn_trd_keg) + vmo(jpdyn_trd_rvo)   &
-            &      + vmo(jpdyn_trd_pvo) + vmo(jpdyn_trd_zad) + vmo(jpdyn_trd_ldf) + vmo(jpdyn_trd_zdf)   &
-            &      + vmo(jpdyn_trd_tau) + vmo(jpdyn_trd_bfr) + vmo(jpdyn_trd_atf) ) / tvolv
+            &     (  umo(jpdyn_hpg) + umo(jpdyn_spg) + umo(jpdyn_keg) + umo(jpdyn_rvo)   &
+            &      + umo(jpdyn_pvo) + umo(jpdyn_zad) + umo(jpdyn_ldf) + umo(jpdyn_zdf)   &
+            &      + umo(jpdyn_tau) + umo(jpdyn_bfr) + umo(jpdyn_atf) ) / tvolu,   &
+            &     (  vmo(jpdyn_hpg) + vmo(jpdyn_spg) + vmo(jpdyn_keg) + vmo(jpdyn_rvo)   &
+            &      + vmo(jpdyn_pvo) + vmo(jpdyn_zad) + vmo(jpdyn_ldf) + vmo(jpdyn_zdf)   &
+            &      + vmo(jpdyn_tau) + vmo(jpdyn_bfr) + vmo(jpdyn_atf) ) / tvolv
          ENDIF
 
@@ -359,20 +355,20 @@
             WRITE (numout,*)
             WRITE (numout,9520) kt
-            WRITE (numout,9521) hke(jpdyn_trd_hpg) / tvolt
-            WRITE (numout,9529) hke(jpdyn_trd_spg) / tvolt
-            WRITE (numout,9522) hke(jpdyn_trd_keg) / tvolt
-            WRITE (numout,9523) hke(jpdyn_trd_rvo) / tvolt
-            WRITE (numout,9524) hke(jpdyn_trd_pvo) / tvolt
-            WRITE (numout,9527) hke(jpdyn_trd_zad) / tvolt
-            WRITE (numout,9525) hke(jpdyn_trd_ldf) / tvolt
-            WRITE (numout,9528) hke(jpdyn_trd_zdf) / tvolt
-            WRITE (numout,9530) hke(jpdyn_trd_tau) / tvolt
-            WRITE (numout,9531) hke(jpdyn_trd_bfr) / tvolt
-            WRITE (numout,9532) hke(jpdyn_trd_atf) / tvolt
+            WRITE (numout,9521) hke(jpdyn_hpg) / tvolt
+            WRITE (numout,9529) hke(jpdyn_spg) / tvolt
+            WRITE (numout,9522) hke(jpdyn_keg) / tvolt
+            WRITE (numout,9523) hke(jpdyn_rvo) / tvolt
+            WRITE (numout,9524) hke(jpdyn_pvo) / tvolt
+            WRITE (numout,9527) hke(jpdyn_zad) / tvolt
+            WRITE (numout,9525) hke(jpdyn_ldf) / tvolt
+            WRITE (numout,9528) hke(jpdyn_zdf) / tvolt
+            WRITE (numout,9530) hke(jpdyn_tau) / tvolt
+            WRITE (numout,9531) hke(jpdyn_bfr) / tvolt
+            WRITE (numout,9532) hke(jpdyn_atf) / tvolt
             WRITE (numout,9533)
             WRITE (numout,9534)   &
-            &     (  hke(jpdyn_trd_hpg) + hke(jpdyn_trd_spg) + hke(jpdyn_trd_keg) + hke(jpdyn_trd_rvo)   &
-            &      + hke(jpdyn_trd_pvo) + hke(jpdyn_trd_zad) + hke(jpdyn_trd_ldf) + hke(jpdyn_trd_zdf)   &
-            &      + hke(jpdyn_trd_tau) + hke(jpdyn_trd_bfr) + hke(jpdyn_trd_atf)  ) / tvolt
+            &     (  hke(jpdyn_hpg) + hke(jpdyn_spg) + hke(jpdyn_keg) + hke(jpdyn_rvo)   &
+            &      + hke(jpdyn_pvo) + hke(jpdyn_zad) + hke(jpdyn_ldf) + hke(jpdyn_zdf)   &
+            &      + hke(jpdyn_tau) + hke(jpdyn_bfr) + hke(jpdyn_atf)  ) / tvolt
          ENDIF
 
@@ -396,12 +392,12 @@
             WRITE (numout,*)
             WRITE (numout,9540) kt
-            WRITE (numout,9541) ( hke(jpdyn_trd_keg) + hke(jpdyn_trd_rvo) + hke(jpdyn_trd_zad) ) / tvolt
-            WRITE (numout,9542) ( hke(jpdyn_trd_keg) + hke(jpdyn_trd_zad) ) / tvolt
-            WRITE (numout,9543) ( hke(jpdyn_trd_pvo) ) / tvolt
-            WRITE (numout,9544) ( hke(jpdyn_trd_rvo) ) / tvolt
-            WRITE (numout,9545) ( hke(jpdyn_trd_spg) ) / tvolt
-            WRITE (numout,9546) ( hke(jpdyn_trd_ldf) ) / tvolt
-            WRITE (numout,9547) ( hke(jpdyn_trd_zdf) ) / tvolt
-            WRITE (numout,9548) ( hke(jpdyn_trd_hpg) ) / tvolt, rpktrd / tvolt
+            WRITE (numout,9541) ( hke(jpdyn_keg) + hke(jpdyn_rvo) + hke(jpdyn_zad) ) / tvolt
+            WRITE (numout,9542) ( hke(jpdyn_keg) + hke(jpdyn_zad) ) / tvolt
+            WRITE (numout,9543) ( hke(jpdyn_pvo) ) / tvolt
+            WRITE (numout,9544) ( hke(jpdyn_rvo) ) / tvolt
+            WRITE (numout,9545) ( hke(jpdyn_spg) ) / tvolt
+            WRITE (numout,9546) ( hke(jpdyn_ldf) ) / tvolt
+            WRITE (numout,9547) ( hke(jpdyn_zdf) ) / tvolt
+            WRITE (numout,9548) ( hke(jpdyn_hpg) ) / tvolt, rpktrd / tvolt
             WRITE (numout,*)
             WRITE (numout,*)
@@ -425,12 +421,12 @@
       CALL wrk_dealloc( jpi, jpj, jpk, zkx, zky, zkz, zkepe )
       !
-   END SUBROUTINE trd_dwr
-
-
-   SUBROUTINE trd_twr( kt )
+   END SUBROUTINE glo_dyn_wri
+
+
+   SUBROUTINE glo_tra_wri( kt )
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_twr  ***
+      !!                  ***  ROUTINE glo_tra_wri  ***
       !! 
-      !! ** Purpose :  write active tracers trends in ocean.output 
+      !! ** Purpose :  write global domain averaged of T and T^2 trends in ocean.output 
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -460,18 +456,18 @@
             WRITE (numout,*)
             WRITE (numout,9400) kt
-            WRITE (numout,9401)  tmo(jptra_trd_xad) / tvolt, smo(jptra_trd_xad) / tvolt
-            WRITE (numout,9411)  tmo(jptra_trd_yad) / tvolt, smo(jptra_trd_yad) / tvolt
-            WRITE (numout,9402)  tmo(jptra_trd_zad) / tvolt, smo(jptra_trd_zad) / tvolt
-            WRITE (numout,9403)  tmo(jptra_trd_ldf) / tvolt, smo(jptra_trd_ldf) / tvolt
-            WRITE (numout,9404)  tmo(jptra_trd_zdf) / tvolt, smo(jptra_trd_zdf) / tvolt
-            WRITE (numout,9405)  tmo(jptra_trd_npc) / tvolt, smo(jptra_trd_npc) / tvolt
-            WRITE (numout,9406)  tmo(jptra_trd_dmp) / tvolt, smo(jptra_trd_dmp) / tvolt
-            WRITE (numout,9407)  tmo(jptra_trd_qsr) / tvolt
-            WRITE (numout,9408)  tmo(jptra_trd_nsr) / tvolt, smo(jptra_trd_nsr) / tvolt
+            WRITE (numout,9401)  tmo(jptra_xad) / tvolt, smo(jptra_xad) / tvolt
+            WRITE (numout,9411)  tmo(jptra_yad) / tvolt, smo(jptra_yad) / tvolt
+            WRITE (numout,9402)  tmo(jptra_zad) / tvolt, smo(jptra_zad) / tvolt
+            WRITE (numout,9403)  tmo(jptra_ldf) / tvolt, smo(jptra_ldf) / tvolt
+            WRITE (numout,9404)  tmo(jptra_zdf) / tvolt, smo(jptra_zdf) / tvolt
+            WRITE (numout,9405)  tmo(jptra_npc) / tvolt, smo(jptra_npc) / tvolt
+            WRITE (numout,9406)  tmo(jptra_dmp) / tvolt, smo(jptra_dmp) / tvolt
+            WRITE (numout,9407)  tmo(jptra_qsr) / tvolt
+            WRITE (numout,9408)  tmo(jptra_nsr) / tvolt, smo(jptra_nsr) / tvolt
             WRITE (numout,9409) 
-            WRITE (numout,9410) (  tmo(jptra_trd_xad) + tmo(jptra_trd_yad) + tmo(jptra_trd_zad) + tmo(jptra_trd_ldf) + tmo(jptra_trd_zdf)   &
-            &                    + tmo(jptra_trd_npc) + tmo(jptra_trd_dmp) + tmo(jptra_trd_qsr) + tmo(jptra_trd_nsr) ) / tvolt,   &
-            &                   (  smo(jptra_trd_xad) + smo(jptra_trd_yad) + smo(jptra_trd_zad) + smo(jptra_trd_ldf) + smo(jptra_trd_zdf)   &
-            &                    + smo(jptra_trd_npc) + smo(jptra_trd_dmp)                   + smo(jptra_trd_nsr) ) / tvolt
+            WRITE (numout,9410) (  tmo(jptra_xad) + tmo(jptra_yad) + tmo(jptra_zad) + tmo(jptra_ldf) + tmo(jptra_zdf)   &
+            &                    + tmo(jptra_npc) + tmo(jptra_dmp) + tmo(jptra_qsr) + tmo(jptra_nsr) ) / tvolt,   &
+            &                   (  smo(jptra_xad) + smo(jptra_yad) + smo(jptra_zad) + smo(jptra_ldf) + smo(jptra_zdf)   &
+            &                    + smo(jptra_npc) + smo(jptra_dmp)                   + smo(jptra_nsr) ) / tvolt
          ENDIF
 
@@ -495,18 +491,18 @@
             WRITE (numout,*)
             WRITE (numout,9420) kt
-            WRITE (numout,9421)   t2(jptra_trd_xad) / tvolt, s2(jptra_trd_xad) / tvolt
-            WRITE (numout,9431)   t2(jptra_trd_yad) / tvolt, s2(jptra_trd_yad) / tvolt
-            WRITE (numout,9422)   t2(jptra_trd_zad) / tvolt, s2(jptra_trd_zad) / tvolt
-            WRITE (numout,9423)   t2(jptra_trd_ldf) / tvolt, s2(jptra_trd_ldf) / tvolt
-            WRITE (numout,9424)   t2(jptra_trd_zdf) / tvolt, s2(jptra_trd_zdf) / tvolt
-            WRITE (numout,9425)   t2(jptra_trd_npc) / tvolt, s2(jptra_trd_npc) / tvolt
-            WRITE (numout,9426)   t2(jptra_trd_dmp) / tvolt, s2(jptra_trd_dmp) / tvolt
-            WRITE (numout,9427)   t2(jptra_trd_qsr) / tvolt
-            WRITE (numout,9428)   t2(jptra_trd_nsr) / tvolt, s2(jptra_trd_nsr) / tvolt
+            WRITE (numout,9421)   t2(jptra_xad) / tvolt, s2(jptra_xad) / tvolt
+            WRITE (numout,9431)   t2(jptra_yad) / tvolt, s2(jptra_yad) / tvolt
+            WRITE (numout,9422)   t2(jptra_zad) / tvolt, s2(jptra_zad) / tvolt
+            WRITE (numout,9423)   t2(jptra_ldf) / tvolt, s2(jptra_ldf) / tvolt
+            WRITE (numout,9424)   t2(jptra_zdf) / tvolt, s2(jptra_zdf) / tvolt
+            WRITE (numout,9425)   t2(jptra_npc) / tvolt, s2(jptra_npc) / tvolt
+            WRITE (numout,9426)   t2(jptra_dmp) / tvolt, s2(jptra_dmp) / tvolt
+            WRITE (numout,9427)   t2(jptra_qsr) / tvolt
+            WRITE (numout,9428)   t2(jptra_nsr) / tvolt, s2(jptra_nsr) / tvolt
             WRITE (numout,9429)
-            WRITE (numout,9430) (  t2(jptra_trd_xad) + t2(jptra_trd_yad) + t2(jptra_trd_zad) + t2(jptra_trd_ldf) + t2(jptra_trd_zdf)   &
-            &                    + t2(jptra_trd_npc) + t2(jptra_trd_dmp) + t2(jptra_trd_qsr) + t2(jptra_trd_nsr) ) / tvolt,   &
-            &                   (  s2(jptra_trd_xad) + s2(jptra_trd_yad) + s2(jptra_trd_zad) + s2(jptra_trd_ldf) + s2(jptra_trd_zdf)   &
-            &                    + s2(jptra_trd_npc) + s2(jptra_trd_dmp)                  + s2(jptra_trd_nsr) ) / tvolt
+            WRITE (numout,9430) (  t2(jptra_xad) + t2(jptra_yad) + t2(jptra_zad) + t2(jptra_ldf) + t2(jptra_zdf)   &
+            &                    + t2(jptra_npc) + t2(jptra_dmp) + t2(jptra_qsr) + t2(jptra_nsr) ) / tvolt,   &
+            &                   (  s2(jptra_xad) + s2(jptra_yad) + s2(jptra_zad) + s2(jptra_ldf) + s2(jptra_zdf)   &
+            &                    + s2(jptra_npc) + s2(jptra_dmp)                  + s2(jptra_nsr) ) / tvolt
          ENDIF
 
@@ -530,15 +526,15 @@
             WRITE (numout,*)
             WRITE (numout,9440) kt
-            WRITE (numout,9441) ( tmo(jptra_trd_xad)+tmo(jptra_trd_yad)+tmo(jptra_trd_zad) )/tvolt,   &
-            &                   ( smo(jptra_trd_xad)+smo(jptra_trd_yad)+smo(jptra_trd_zad) )/tvolt
-            WRITE (numout,9442)   tmo(jptra_trd_sad)/tvolt,  smo(jptra_trd_sad)/tvolt
-            WRITE (numout,9443)   tmo(jptra_trd_ldf)/tvolt,  smo(jptra_trd_ldf)/tvolt
-            WRITE (numout,9444)   tmo(jptra_trd_zdf)/tvolt,  smo(jptra_trd_zdf)/tvolt
-            WRITE (numout,9445)   tmo(jptra_trd_npc)/tvolt,  smo(jptra_trd_npc)/tvolt
-            WRITE (numout,9446) ( t2(jptra_trd_xad)+t2(jptra_trd_yad)+t2(jptra_trd_zad) )/tvolt,    &
-            &                   ( s2(jptra_trd_xad)+s2(jptra_trd_yad)+s2(jptra_trd_zad) )/tvolt
-            WRITE (numout,9447)   t2(jptra_trd_ldf)/tvolt,   s2(jptra_trd_ldf)/tvolt
-            WRITE (numout,9448)   t2(jptra_trd_zdf)/tvolt,   s2(jptra_trd_zdf)/tvolt
-            WRITE (numout,9449)   t2(jptra_trd_npc)/tvolt,   s2(jptra_trd_npc)/tvolt
+            WRITE (numout,9441) ( tmo(jptra_xad)+tmo(jptra_yad)+tmo(jptra_zad) )/tvolt,   &
+            &                   ( smo(jptra_xad)+smo(jptra_yad)+smo(jptra_zad) )/tvolt
+            WRITE (numout,9442)   tmo(jptra_sad)/tvolt,  smo(jptra_sad)/tvolt
+            WRITE (numout,9443)   tmo(jptra_ldf)/tvolt,  smo(jptra_ldf)/tvolt
+            WRITE (numout,9444)   tmo(jptra_zdf)/tvolt,  smo(jptra_zdf)/tvolt
+            WRITE (numout,9445)   tmo(jptra_npc)/tvolt,  smo(jptra_npc)/tvolt
+            WRITE (numout,9446) ( t2(jptra_xad)+t2(jptra_yad)+t2(jptra_zad) )/tvolt,    &
+            &                   ( s2(jptra_xad)+s2(jptra_yad)+s2(jptra_zad) )/tvolt
+            WRITE (numout,9447)   t2(jptra_ldf)/tvolt,   s2(jptra_ldf)/tvolt
+            WRITE (numout,9448)   t2(jptra_zdf)/tvolt,   s2(jptra_zdf)/tvolt
+            WRITE (numout,9449)   t2(jptra_npc)/tvolt,   s2(jptra_npc)/tvolt
          ENDIF
 
@@ -558,6 +554,6 @@
       ENDIF
       !
-   END SUBROUTINE trd_twr
+   END SUBROUTINE glo_tra_wri
 
    !!======================================================================
-END MODULE trdicp
+END MODULE trdglo